unit Unit1;

interface

uses
  Windows, Messages, Dialogs, MessDlgs, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  XiButton, Grids, DateUtils, ComCtrls, ExtCtrls, XiPanel, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    XiPanel1: TXiPanel;
    XiButton1: TXiButton;
    XiButton3: TXiButton;
    XiButton4: TXiButton;
    XiButton5: TXiButton;
    XiButton6: TXiButton;
    laske: TXiButton;
    taysikierroksia: TComboBox;
    psumma: TLabel;
    ppelot: TXiButton;
    XiButton8: TXiButton;
    SaveDialog1: TSaveDialog;
    otsikko: TEdit;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Tiedosto1: TMenuItem;
    lopeta1: TMenuItem;
    Asetukset1: TMenuItem;
    Yleisetasetukset1: TMenuItem;
    XiPanel2: TXiPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    sg1: TStringGrid;
    sg2: TStringGrid;
    sg3: TStringGrid;
    XiButton9: TXiButton;
    ComboBox2: TComboBox;
    vajaakierroksia: TComboBox;
    paivays: TEdit;
    XiButton2: TXiButton;
    PopupMenu1: TPopupMenu;
    Poista1: TMenuItem;
    N2: TMenuItem;
    Versio1: TMenuItem;
    taydennys: TTimer;
    uusipelaaja: TXiPanel;
    Uudenpelaajannimi: TEdit;
    Uudenpelaajanpelo: TEdit;
    Luouusipelaaja: TXiButton;
    XiButton10: TXiButton;
    Uudenpelaajanseura: TEdit;
    uusipelaajaotsikko: TLabel;
    asetukset: TXiPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    cbnaytaseura: TCheckBox;
    XiButton11: TXiButton;
    cbuusipelo: TCheckBox;
    cbseura: TCheckBox;
    cbvanhapelo: TCheckBox;
    cbmuutos: TCheckBox;
    cbvertailu: TCheckBox;
    cbryhma: TCheckBox;
    pelopolku: TEdit;
    cbsija: TCheckBox;
    Pelityyppi: TComboBox;
    procedure XiButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure XiButton3Click(Sender: TObject);
    procedure SortGrid(Grid: TStringGrid);
    procedure XiButton2Click(Sender: TObject);
    procedure sg1DblClick(Sender: TObject);
    procedure sg2DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure sg1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure sg2SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure tarkista;
    procedure lataa_pelaajalista(path: string);
    procedure laskeClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure XiButton6Click(Sender: TObject);
    procedure XiButton4Click(Sender: TObject);
    procedure XiButton5Click(Sender: TObject);
    procedure taysikierroksiaChange(Sender: TObject);
    procedure lataahistoria;
    procedure sg2Exit(Sender: TObject);
    procedure ppelotClick(Sender: TObject);
    procedure XiButton8Click(Sender: TObject);
    procedure lopeta1Click(Sender: TObject);
    procedure Yleisetasetukset1Click(Sender: TObject);
    procedure XiButton9Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure paivaysExit(Sender: TObject);
    procedure Poista1Click(Sender: TObject);
    procedure sg2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Versio1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure gridKeyPress(Sender: TObject; var Key: Char);
    procedure taydennysTimer(Sender: TObject);
    procedure XiButton10Click(Sender: TObject);
    procedure LuouusipelaajaClick(Sender: TObject);
    procedure XiButton11Click(Sender: TObject);
    procedure cbuusipeloClick(Sender: TObject);
    procedure cbnaytaseuraClick(Sender: TObject);
    procedure PelityyppiChange(Sender: TObject);
    function kokonaisluvuksi(source: string): integer;
    function desimaaliluvuksi(source: string): extended;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    nimi, seura, ryhma, vanhapelo, pisteet, vertailu, uusipelo, muutos, sija, empty: integer;
    pelaajalistan_nimi, autocomplete: string;
    uudenpelaajantapa, pcl, se, pl, up, vp, mu, ve, ry, si: integer;
    pelaajalista_tallennettu, taulukko_tallennettu: boolean;
    { Public declarations }
  end;

const tausta1=$00fefefe;
      tausta2=$00fff4ec;
      tausta3=Clskyblue;
      tausta4=$00cccccc;
      tausta5=$00cbb3a2;
      {$IFDEF FPC}zero_width = 0;{$ELSE}zero_width = -1;{$ENDIF}
      vakio_tallentamatta: string='Pelaajalistaa ei ole tallennettu!'+#13#13+'Tallennetaanko?';
      vakio_tallentamatta2: string='Taulukkoa ei ole tallennettu!'+#13#13+'Tallennetaanko?';
var
  Form1: TForm1;

implementation

uses Unit5;

{$R *.dfm}

function TForm1.kokonaisluvuksi(source: string): integer;
var errorpos: integer;
begin
 val(source, result, errorpos);
 if errorpos<>0 then result:=-1;
end;

function TForm1.desimaaliluvuksi(source: string): extended;
var errorpos: integer;
begin
 decimalseparator:='.';
 source:=stringreplace(source, ',', '.', []);
 val(source, result, errorpos);
 if errorpos<>0 then result:=-1;
end;

procedure lisaapelaaja(sg: TStringGrid; a, b, c: string);
var i, rivi: integer;
begin
 rivi:=0;
 for i:=0 to sg.RowCount-1 do
  if length(sg.cells[0,i])>2 then rivi:=rivi+1;
 if rivi=sg.RowCount then sg.RowCount:=sg.RowCount+1;
  sg.cells[0,rivi]:=a;
  sg.cells[1,rivi]:=b;
  sg.cells[2,rivi]:=c;
end;

function paiva(l: string): string;
var s, s2: TDate;
 m: char;
 e: extended;
begin
 m:=dateseparator;
 dateseparator:='/';
 l:=copy(l,1,2)+'/'+copy(l,3,2)+'/20'+copy(l, 5,2);
 s:=StrToDateTime('01/01/1970');
 s2:=StrToDateTime(l);
 e:=daysbetween(s, s2)*24*60*60;
 result:=floattostr(e)+'000';
 dateseparator:=m;
end;

procedure TForm1.lataahistoria;
var j, x: integer;
 s, s1, s2, path: string;
 m: TStringlist;
begin
 path:=stringreplace(form1.pelaajalistan_nimi, '.dat', '.log',[]);
 m:=TStringlist.Create;
 s:=paiva(copy(form1.paivays.text, 1, 2)+copy(form1.paivays.text, 4, 2)+copy(form1.paivays.text, 9, 2));
 if fileexists(path) then m.LoadFromFile(path) else m.text:='';
 for j:=1 to form1.sg2.rowCount-1 do
  begin
  if form1.sg2.Cells[form1.nimi, j]='' then continue;
  if ansipos(form1.sg2.Cells[form1.nimi, j], m.text)>0 then
  begin
   s1:=copy(m.text, 1, ansipos(form1.sg2.Cells[form1.nimi, j], m.text));
   s2:=copy(m.Text, ansipos(form1.sg2.Cells[form1.nimi, j], m.text)+1, length(m.text)-ansipos(form1.sg2.Cells[form1.nimi, j], m.text));
   x:=ansipos('*', s2);
   if x>0 then s2:=stringreplace(s2, '*',  ',['+s+', '+form1.sg2.Cells[form1.uusipelo, j]+']'+#13#10+'*', []) else s2:=s2+#13#10+',['+s+', '+form1.sg2.Cells[form1.uusipelo, j]+']';
   m.text:=s1+s2;
  end
  else
   m.Add('*'+form1.sg2.Cells[form1.nimi, j]+':['+s+', '+form1.sg2.Cells[form1.vanhapelo, j]+']'+#13#10+',['+s+', '+form1.sg2.Cells[form1.uusipelo, j]+']');
  end;
 m.SaveToFile(path);
 m.free;
end;

function tarkistapaivays: boolean;
var p: integer;
begin
 result:=false;
 p:=form1.kokonaisluvuksi(copy(form1.paivays.text, 1, 2));
 if (p<1) or (p>31) then exit;
 p:=form1.kokonaisluvuksi(copy(form1.paivays.text, 4, 2));
 if (p<1) or (p>12) then exit;
 p:=form1.kokonaisluvuksi(copy(form1.paivays.text, 7, 4));
 if (p<2000) or (p>2040) then exit;
 result:=true;
end;

function RoundCorrect(R: Real): LongInt;
begin
 result:=Trunc(R); // extract the integer part
 if Frac(R)>=0.5 then result:=result+1; // if fractional part >= 0.5 then add 1
end;

procedure avaahtm(path: string);
var f: textfile;
    TmpStr, temppi: string;
    tmp, x, x2, i, j, k, l, rivi, sarake, tyyppi: integer;
    grid: TStringGrid;
begin
 form1.taulukko_tallennettu:=true;
 grid:=TStringGrid.Create(nil);
 grid.RowCount:=2;
 grid.ColCount:=2;
 AssignFile(F, path);
 Reset(F);
 rivi:=0;
 sarake:=0;
 tyyppi:=0;
 while not eof(F) do
 begin
  readln(F, TmpStr);
  x2:=ansipos('<!--vajaak-->', ansilowercase(tmpstr));
  if x2>0 then
  begin
   tmp:=ansipos('<!--kierroksia', ansilowercase(tmpstr));
   if tmp>0 then
   begin
    temppi:=copy(tmpstr, tmp+14, length(tmpstr)-tmp-13);
    temppi:=copy(temppi, 1, ansipos('-->', temppi)-1);
    form1.vajaakierroksia.itemindex:=form1.vajaakierroksia.Items.IndexOf(temppi);
   end;
   tyyppi:=1;
  end;
  x2:=ansipos('<!--taysik-->', ansilowercase(tmpstr));
  if x2>0 then
  begin
   tmp:=ansipos('<!--kierroksia', ansilowercase(tmpstr));
   if tmp>0 then
   begin
    temppi:=copy(tmpstr, tmp+14, length(tmpstr)-tmp-13);
    temppi:=copy(temppi, 1, ansipos('-->', temppi)-1);
    form1.taysikierroksia.itemindex:=form1.taysikierroksia.Items.IndexOf(temppi);
   end;
   tyyppi:=2;
  end;
  x2:=ansipos('>uusi pelo<', ansilowercase(tmpstr));
  if x2>0 then tyyppi:=0;
  x2:=ansipos('<!--date-->', ansilowercase(tmpstr));
  if x2>0 then
  begin
   temppi:=copy(tmpstr, x2+11, length(tmpstr)-x2-10);
   temppi:=copy(temppi, 1, ansipos('<', temppi)-1);
   form1.paivays.text:=temppi;
  end;
  x2:=ansipos('<!--title-->', ansilowercase(tmpstr));
  if x2>0 then
  begin
   temppi:=copy(tmpstr, x2+12, length(tmpstr)-x2-11);
   temppi:=copy(temppi, 1, ansipos('<', temppi)-1);
   if copy(temppi, length(temppi),1)=' ' then temppi:=copy(temppi, 1, length(temppi)-1);
   form1.otsikko.text:=temppi;
  end;
  x:=ansipos('<P ALIGN=LEFT>', ansiuppercase(tmpstr));
  if x>0 then
  begin
   tmpstr:=copy(tmpstr, x+14, length(tmpstr)-x-13);
   l:=ansipos('<a href', ansilowercase(tmpstr));
   if l>0 then
   begin
    tmpstr:=copy(tmpstr, ansipos('>', tmpstr)+1, length(tmpstr)-ansipos('>', tmpstr));
    tmpstr:=stringreplace(tmpstr, '</a>', '', [rfignorecase]);
   end;
   if rivi>=grid.rowcount then grid.rowcount:=rivi+1;
   if sarake>=grid.colcount then grid.colcount:=sarake+1;
   grid.Cells[sarake,rivi]:=stringreplace(copy(tmpstr, 1, ansipos('</P>', ansiuppercase(tmpstr))-1), '<BR>', '', [rfignorecase]);
   sarake:=sarake+1;
  end;
  if ansipos('</TR>', ansiuppercase(tmpstr))>0 then
  begin
   sarake:=0;
   rivi:=rivi+1;
  end;
 end;
 closefile(f);
 for i:=1 to form1.sg2.rowcount-1 do
  for j:=0 to form1.sg2.colcount-1 do
   form1.sg2.cells[j,i]:='';
 form1.sg2.RowCount:=grid.rowcount;
 for i:=0 to grid.ColCount-1 do
  for j:=i to form1.sg2.colcount-1 do
   if grid.Cells[i,0]=form1.sg2.cells[j,0] then
   begin
    if j>0 then
    for k:=0 to grid.rowcount-1 do
     form1.sg2.cells[j,k]:=grid.Cells[i,k];
   end;
 grid.Free;
 form1.Pelityyppi.ItemIndex:=tyyppi;
 form1.pelityyppichange(nil);
end;

procedure SortGrid2(Grid: TStringGrid; Col: integer);
var i, j, prev2: integer;
    a, b, prev: string;
    taulu: array of string;
    taulu2: array of integer;
    taulu3: array of array of string;
begin
 setlength(taulu, grid.rowCount);
 setlength(taulu2, grid.rowCount);
 setlength(taulu3, grid.colCount, grid.rowCount);
 for j:=1 to Grid.RowCount-1 do
  begin
   taulu[j]:=(Grid.Cells[Col, j]);
   taulu2[j]:=j;
  end;
  //vaihda:=false;
  for j:=0 to Grid.RowCount-1 do
   for i:=2 to Grid.RowCount-1 do
    begin
      a:=taulu[i];
      b:=taulu[i-1];
     {if vaihda=true then
      begin
       tmp:=a;
       a:=b;
       b:=tmp;
      end; }
      if (a<>'') and (b<>'') then
      begin
       if ansipos('.', a)=0 then a:=a+'.0';
       if ansipos('.', b)=0 then b:=b+'.0';
       if ((ansilowercase(a)>ansilowercase(b)) and (length(a)=length(b))) or (length(a)>length(b)) then
       begin
        prev:=taulu[i-1];
        taulu[i-1]:=taulu[i];
        taulu[i]:=prev;
        prev2:=taulu2[i-1];
        taulu2[i-1]:=taulu2[i];
        taulu2[i]:=prev2;
       end;
     end;
  end;
  for i:=0 to grid.colcount-1 do
   for j:=1 to Grid.RowCount-1 do
    taulu3[i,j]:=Grid.cells[i,j];
  for i:=0 to grid.colcount-1 do
   for j:=1 to Grid.RowCount-1 do
    Grid.cells[i,j]:=taulu3[i, taulu2[j]];
  for j:=1 to Grid.RowCount-1 do
   Grid.cells[0, j]:='';
end;

procedure katsoryhma;
var i, j, laskuri, lahinsuurin, lahinpienin: integer;
begin
 if form1.sg2.RowCount-1<6 then
 begin
  for j:=1 to form1.sg2.rowcount-1 do
   form1.sg2.cells[form1.ryhma,j]:='A';
  exit;
 end;
 laskuri:=0;
 lahinsuurin:=2000;
 lahinpienin:=2000;
 for j:=1 to form1.sg2.rowcount-1 do
 begin
 for i:=1 to form1.sg2.rowcount-1 do
  begin
   if (i<>j) and (form1.sg2.cells[form1.vanhapelo,j]>=form1.sg2.cells[form1.vanhapelo,i]) then laskuri:=laskuri+1;
   if (i<>j) and (strtoint(form1.sg2.cells[form1.vanhapelo,j])>=strtoint(form1.sg2.cells[form1.vanhapelo,i])) then if strtoint(form1.sg2.cells[form1.vanhapelo,j])-strtoint(form1.sg2.cells[form1.vanhapelo,i])<lahinsuurin then lahinsuurin:=strtoint(form1.sg2.cells[form1.vanhapelo,j])-strtoint(form1.sg2.cells[form1.vanhapelo,i]);
   if (i<>j) and (strtoint(form1.sg2.cells[form1.vanhapelo,j])<strtoint(form1.sg2.cells[form1.vanhapelo,i])) then if strtoint(form1.sg2.cells[form1.vanhapelo,i])-strtoint(form1.sg2.cells[form1.vanhapelo,j])<lahinpienin then lahinpienin:=strtoint(form1.sg2.cells[form1.vanhapelo,i])-strtoint(form1.sg2.cells[form1.vanhapelo,j]);
  end;
  if laskuri>(form1.sg2.rowcount-2)/2 then form1.sg2.cells[form1.ryhma,j]:='A';
  if laskuri<(form1.sg2.rowcount-2)/2 then form1.sg2.cells[form1.ryhma,j]:='B';
  if laskuri=(form1.sg2.rowcount-2)/2 then
  begin
   if lahinpienin>lahinsuurin then form1.sg2.cells[form1.ryhma,j]:='B' else form1.sg2.cells[form1.ryhma,j]:='A';
  end;
  laskuri:=0;
  lahinsuurin:=2000;
  lahinpienin:=2000;
 end;
end;

procedure sijat;
var i, j, l, laskuri, laskuri2: integer;
begin
 laskuri2:=form1.sg2.rowcount;
 laskuri:=0;
 for i:=0 to (form1.sg2.rowcount-1)*2*(form1.taysikierroksia.itemindex+2) do
  begin
   for j:=1 to form1.sg2.rowcount-1 do
   begin
    if strtofloat(form1.sg2.cells[form1.pisteet,j])=(i/2) then laskuri:=laskuri+1;
   end;
  if laskuri>0 then
  begin
   for l:=1 to form1.sg2.rowcount-1 do
   if strtofloat(form1.sg2.cells[form1.pisteet,l])=(i/2) then
   begin
   if laskuri<>1 then form1.sg2.cells[form1.sija,l]:=inttostr(laskuri2-laskuri)+'-'+inttostr(laskuri2-1)+'.'
     else form1.sg2.cells[form1.sija,l]:=inttostr(laskuri2-laskuri)+'.';
   end;
   laskuri2:=laskuri2-laskuri;
  end;
  laskuri:=0;
 end;
end;

procedure Tallenna_pelaajalista;
var f: textfile;
    path, tmpstr: string;
    i: integer;
begin
 path:=form1.pelaajalistan_nimi;
 AssignFile(F, path);
 Rewrite(F);
 for i:=1 to form1.sg1.RowCount-1 do
  if form1.sg1.cells[0,i]<>'' then
  begin
   tmpstr:='A:'+form1.sg1.cells[0,i]+','+form1.sg1.cells[1,i]+','+form1.sg1.cells[2,i];
   writeln(f, tmpstr);
  end;
 for i:=1 to form1.sg3.RowCount-1 do
  if form1.sg3.cells[0,i]<>'' then
  begin
   tmpstr:='P:'+form1.sg3.cells[0,i]+','+form1.sg3.cells[1,i]+','+form1.sg3.cells[2,i];
   writeln(f, tmpstr);
  end;
 closefile(f);
 form1.pelaajalista_tallennettu:=true;
end;

procedure TForm1.lataa_pelaajalista(path: string);
var f: textfile;
    TmpStr, a, b, c: string;
    i, j, p: integer;
begin
 if fileexists(path) then
 begin
  //tyhjennetn vanhat
  for i:=1 to form1.sg1.rowcount-1 do
   for j:=0 to form1.sg1.colcount-1 do
    form1.sg1.cells[j,i]:='';
  for i:=1 to form1.sg3.rowcount-1 do
   for j:=0 to form1.sg3.colcount-1 do
    form1.sg3.cells[j,i]:='';
  sg1.rowcount:=2;
  sg3.RowCount:=2;

  AssignFile(F, path);
  Reset(F);
  while not eof(F) do
   begin
   readln(F, TmpStr);
   p:=ansipos('A:', TmpStr);
   if (p=1) then
   begin
    a:=copy(tmpstr, 3, ansipos(',', tmpstr)-3);
    tmpstr:=copy(tmpstr, ansipos(',', tmpstr)+1, length(tmpstr)-ansipos(',', tmpstr));
    b:=copy(tmpstr, 1, ansipos(',', tmpstr)-1);
    c:=copy(tmpstr, ansipos(',', tmpstr)+1, 4);
    lisaapelaaja(sg1, a, b, c);
   end;
   p:=ansipos('P:', TmpStr);
   if (p=1) then
   begin
    a:=copy(tmpstr, 3, ansipos(',', tmpstr)-3);
    tmpstr:=copy(tmpstr, ansipos(',', tmpstr)+1, length(tmpstr)-ansipos(',', tmpstr));
    b:=copy(tmpstr, 1, ansipos(',', tmpstr)-1);
    c:=copy(tmpstr, ansipos(',', tmpstr)+1, 4);
    lisaapelaaja(sg3, a, b, c);
   end;
  end;
  closefile(f);
  form1.sortgrid(form1.sg1);
  pelaajalista_tallennettu:=true;
 end;
end;

function palautakerroin(a: integer): integer;
var i: integer;
begin
 i:=45;
 if a>=1650 then i:=40;
 if a>=1750 then i:=35;
 if a>=1850 then i:=30;
 if a>=1950 then i:=25;
 if a>=2050 then i:=20;
 result:=i;
end;

function odotustulos(a, b: integer): integer;
var i, j: integer;
begin
 if a>b then j:=a-b else j:=b-a;
 i:=0;
 if j<736 then i:=1;
 if j<620 then i:=2;
 if j<560 then i:=3;
 if j<518 then i:=4;
 if j<485 then i:=5;
 if j<457 then i:=6;
 if j<433 then i:=7;
 if j<412 then i:=8;
 if j<392 then i:=9;
 if j<375 then i:=10;
 if j<358 then i:=11;
 if j<345 then i:=12;
 if j<329 then i:=13;
 if j<316 then i:=14;
 if j<303 then i:=15;
 if j<291 then i:=16;
 if j<279 then i:=17;
 if j<268 then i:=18;
 if j<257 then i:=19;
 if j<246 then i:=20;
 if j<236 then i:=21;
 if j<226 then i:=22;
 if j<216 then i:=23;
 if j<207 then i:=24;
 if j<198 then i:=25;
 if j<189 then i:=26;
 if j<180 then i:=27;
 if j<171 then i:=28;
 if j<163 then i:=29;
 if j<154 then i:=30;
 if j<146 then i:=31;
 if j<138 then i:=32;
 if j<130 then i:=33;
 if j<122 then i:=34;
 if j<114 then i:=35;
 if j<107 then i:=36;
 if j<99 then i:=37;
 if j<92 then i:=38;
 if j<84 then i:=39;
 if j<77 then i:=40;
 if j<69 then i:=41;
 if j<62 then i:=42;
 if j<54 then i:=43;
 if j<47 then i:=44;
 if j<40 then i:=45;
 if j<33 then i:=46;
 if j<26 then i:=47;
 if j<18 then i:=48;
 if j<11 then i:=49;
 if j<4 then i:=50;
 if a>b then result:=100-i else result:=i;
end;

procedure TForm1.tarkista;
var i, p: integer;
    p2, laskuri, laskuri2: extended;
    m: char;
    virhe: boolean;
begin
 ppelot.enabled:=false;
 m:=decimalseparator;
 laskuri:=0;
 virhe:=false;
 decimalseparator:='.';
 for i:=1 to form1.sg2.rowcount-1 do
 begin
  form1.sg2.Cells[pisteet,i]:=stringreplace(form1.sg2.Cells[pisteet, i], ',', '.', []);
  form1.sg2.Cells[pisteet,i]:=stringreplace(form1.sg2.Cells[pisteet, i], '', '.5', []);
  if form1.sg2.Cells[pisteet,i]='.5' then form1.sg2.Cells[pisteet,i]:='0.5';
  p:=kokonaisluvuksi(form1.sg2.Cells[pisteet,i]);
  p2:=desimaaliluvuksi(form1.sg2.Cells[pisteet,i]);
  if p2<0 then form1.sg2.Cells[pisteet,i]:='';
  if (p<0) and (ansipos('.5', form1.sg2.Cells[pisteet,i])=0) then form1.sg2.Cells[pisteet, i]:='';
 end;
 for i:=1 to form1.sg2.rowcount-1 do
  if form1.sg2.Cells[pisteet,i]<>'' then laskuri:=laskuri+strtofloat(form1.sg2.Cells[pisteet,i]) else virhe:=true;
 laskuri2:=((sg2.RowCount-2)*(sg2.rowcount-1)/2)*(taysikierroksia.ItemIndex+1);
 if laskuri2<>laskuri then psumma.Font.Color:=clred else psumma.Font.Color:=clblack;
 if combobox2.itemindex=0 then psumma.caption:=floattostr(laskuri)+'('+floattostr(laskuri2)+')' else psumma.caption:=floattostr(laskuri)+'('+inttostr((vajaakierroksia.itemindex+5)*roundcorrect((sg2.rowcount-1)/2))+')';
 decimalseparator:=m;
 if virhe=true then begin form1.laske.enabled:=false; exit; end;
 if form1.sg2.rowcount<3 then begin form1.laske.enabled:=false; exit; end;
 form1.laske.Enabled:=true;
end;

procedure DeleteRow(Grid: TStringGrid; ARow: Integer);
var i: integer;
begin
 if Grid.rowcount=2 then
 begin
  for i:=0 to Grid.colcount-1 do
   Grid.cells[i,arow]:='';
  exit;
 end;
 with Grid do
 begin
  for i:=ARow to RowCount-2 do
   Rows[i].Assign(Rows[i+1]);
  RowCount:=RowCount-1;
 end;
end;

procedure TForm1.SortGrid(Grid: TStringGrid);
var i, j, prev2: integer;
    a, b, prev: string;
    taulu: array of string;
    taulu2: array of integer;
    taulu3: array of array of string;
begin
 setlength(taulu, grid.rowCount);
 setlength(taulu2, grid.rowCount);
 setlength(taulu3, grid.colCount, grid.rowCount);
 for j:=1 to Grid.RowCount-1 do
  begin
   taulu[j]:=(Grid.Cells[0, j]);
   taulu2[j]:=j;
  end;
  for j:=0 to Grid.RowCount-1 do
   for i:=2 to Grid.RowCount-1 do
   begin
     a:=taulu[i];
     b:=taulu[i-1];
     if (a<>'') and (b<>'') then
     begin
      if ansilowercase(a)<ansilowercase(b) then
      begin
       prev:=taulu[i-1];
       taulu[i-1]:=taulu[i];
       taulu[i]:=prev;
       prev2:=taulu2[i-1];
       taulu2[i-1]:=taulu2[i];
       taulu2[i]:=prev2;
      end;
    end;
   end;
  for i:=0 to Grid.Colcount-1 do
   for j:=1 to Grid.RowCount-1 do
    taulu3[i,j]:=Grid.cells[i,j];
  for i:=0 to Grid.Colcount-1 do
   for j:=1 to Grid.RowCount-1 do
    Grid.cells[i,j]:=taulu3[i, taulu2[j]];
end;

procedure TForm1.XiButton1Click(Sender: TObject);
begin
 uusipelaaja.top:=(Xipanel2.Height div 2)-uusipelaaja.Height div 2;
 uusipelaaja.left:=(Xipanel2.Width div 2)-uusipelaaja.Width div 2;
 uusipelaajaotsikko.caption:='Luo uusi pelaaja';
 uudenpelaajantapa:=1;
 uusipelaaja.Visible:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 sg1.Cells[0,0]:='Pelaaja';
 sg1.Cells[1,0]:='Seura';
 sg1.Cells[2,0]:='Pelo';
 sg3.Cells[0,0]:='Pelaaja';
 sg3.Cells[1,0]:='Seura';
 sg3.Cells[2,0]:='Pelo';
 nimi:=1;
 seura:=2;
 ryhma:=3;
 pisteet:=4;
 vanhapelo:=5;
 uusipelo:=6;
 muutos:=7;
 vertailu:=8;
 sija:=9;
 empty:=10;
 sg2.Cells[0,0]:='Nr';
 sg2.Cells[nimi,0]:='Pelaaja';
 sg2.Cells[seura,0]:='Seura';
 sg2.Cells[ryhma,0]:='Ryhm';
 sg2.Cells[vanhapelo,0]:='Vanha pelo';
 sg2.Cells[pisteet,0]:='Pisteet';
 sg2.Cells[uusipelo,0]:='Uusi pelo';
 sg2.Cells[muutos,0]:='Muutos';
 sg2.Cells[vertailu,0]:='Vertailu';
 sg2.Cells[sija,0]:='Sija';
 sg2.ColWidths[0]:=20;
 sg2.ColWidths[nimi]:=110;
 sg2.ColWidths[seura]:=50;
 sg2.ColWidths[ryhma]:=40;
 sg2.ColWidths[vanhapelo]:=60;
 sg2.ColWidths[pisteet]:=40;
 sg2.ColWidths[uusipelo]:=60;
 sg2.ColWidths[muutos]:=45;
 sg2.ColWidths[vertailu]:=45;
 sg2.ColWidths[sija]:=35;
 sg2.ColWidths[empty]:=zero_width;
 sg2.Col:=empty;
 otsikko.text:='Pikapeli';
 pelaajalistan_nimi:=stringreplace(ExtractFilePath(ParamStr(0)), '/', '\', [rfreplaceall])+'pikapeli.dat';
 lataa_pelaajalista(pelaajalistan_nimi);
 taulukko_tallennettu:=true;
end;

procedure TForm1.XiButton3Click(Sender: TObject);
begin
 if (sg1.row<1) or (sg1.cells[0,sg1.row]='') then exit;
 uudenpelaajantapa:=2;
 uusipelaajaotsikko.caption:='Muokkaa pelaajaa';
 uudenpelaajannimi.text:=sg1.cells[0,sg1.row];
 uudenpelaajanseura.text:=sg1.cells[1,sg1.row];
 uudenpelaajanpelo.text:=sg1.cells[2,sg1.row];
 uusipelaaja.visible:=true;
end;

procedure TForm1.XiButton2Click(Sender: TObject);
begin
 form5.visible:=true;
end;

procedure TForm1.sg1DblClick(Sender: TObject);
var i, rivi: integer;
begin
 rivi:=0;
 for i:=1 to form1.sg2.RowCount-1 do
  if sg2.Cells[nimi,i]=sg1.Cells[sg1.Col, sg1.Row] then exit;
 if (sg1.row<1) or (length(sg1.cells[0, sg1.row])<3) then exit;
 for i:=0 to form1.sg2.RowCount-1 do
  if length(form1.sg2.cells[nimi,i])>2 then rivi:=rivi+1;
 if rivi=form1.sg2.RowCount then form1.sg2.RowCount:=form1.sg2.RowCount+1;
 sg2.cells[nimi,rivi]:=sg1.cells[0,sg1.row];
 sg2.cells[seura,rivi]:=sg1.cells[1,sg1.row];
 sg2.cells[vanhapelo,rivi]:=sg1.cells[2,sg1.row];
 sg2.invalidate;
 taulukko_tallennettu:=false;
 tarkista;
end;

procedure TForm1.sg2DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
 if (aRow=0) then sg2.Canvas.Brush.Color:=tausta5
 else
 begin
  if aRow mod 2=0 then sg2.Canvas.Brush.Color:=tausta1 else sg2.Canvas.Brush.Color:=tausta2;
 end;
 if (arow=sg2.Row) and (acol=sg2.col) then sg2.Canvas.Brush.Color:=tausta3;
 sg2.Canvas.FillRect(Rect);
 if (acol=0) and (arow>0) then sg2.Canvas.Textout(Rect.Left+2, Rect.Top, inttostr(arow)+'.');
 sg2.Canvas.Textout(Rect.Left+2, Rect.Top, sg2.cells[acol, arow]);
end;

procedure TForm1.sg1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
 if (aRow=0) then (sender as TStringgrid).Canvas.Brush.Color:=tausta5
  else
  begin
   if aRow mod 2=0 then (sender as tstringgrid).Canvas.Brush.Color:=tausta1 else (sender as TStringgrid).Canvas.Brush.Color:=tausta2;
  end;
 if (arow=(sender as tstringgrid).Row) and (acol=(sender as tstringgrid).col) then (sender as TStringgrid).Canvas.Brush.Color:=tausta3;
 (sender as TStringgrid).Canvas.FillRect(Rect);
 (sender as TStringgrid).Canvas.font.color:=clblack;
 (sender as TStringgrid).Canvas.Textout(Rect.Left+2, Rect.Top, (sender as TStringgrid).cells[acol, arow]);
end;

procedure TForm1.sg2SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
 tarkista;
 if (acol=pisteet) or (acol=vanhapelo) or (acol=sija) or (acol=vertailu) then sg2.options:=sg2.options+[goediting] else sg2.options:=sg2.options-[goediting];
end;

procedure TForm1.laskeClick(Sender: TObject);
var i, j, k, luku, kerroin, pelonmuutos: integer;
    m: char;
begin
 if tarkistapaivays=false then begin form1.paivaysexit(self); exit; end;
 m:=decimalseparator;
 decimalseparator:='.';
 for i:=1 to sg2.RowCount-1 do
 begin
  luku:=0;
  for k:=0 to form1.taysikierroksia.itemindex do
   for j:=1 to sg2.RowCount-1 do
    if j<>i then
     luku:=luku+odotustulos(strtoint(sg2.cells[vanhapelo,i]), strtoint(sg2.cells[vanhapelo,j]));
     //sg2.Cells[odotus,i]:=floattostr(luku/100);
   kerroin:=palautakerroin(strtoint(sg2.cells[vanhapelo,i]));
   sg2.cells[uusipelo,i]:=inttostr(strtoint(sg2.cells[vanhapelo,i])+roundcorrect(kerroin*(strtofloat(sg2.cells[pisteet,i])-luku/100)));
   pelonmuutos:=strtoint(sg2.Cells[uusipelo,i])-strtoint(sg2.Cells[vanhapelo,i]);
   if pelonmuutos>=0 then sg2.Cells[muutos,i]:='+'+inttostr(pelonmuutos) else sg2.Cells[muutos,i]:=inttostr(pelonmuutos);
 end;
 sijat;
 katsoryhma;
 sortgrid2(sg2, form1.pisteet);
 taulukko_tallennettu:=false;
 sg2.Invalidate;
 ppelot.Enabled:=true;
 decimalseparator:=m;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
 if pagecontrol1.ActivePage.pageindex=0 then
 begin
  xibutton1.Visible:=true;
  xibutton3.Visible:=true;
  xibutton4.Visible:=true;
  xibutton5.Visible:=false;
  xibutton6.Visible:=false;
 end;
 if pagecontrol1.ActivePage.pageindex=1 then
 begin
  xibutton1.Visible:=false;
  xibutton3.Visible:=false;
  xibutton4.Visible:=false;
  xibutton5.Visible:=true;
  xibutton6.Visible:=true;
 end
end;

procedure TForm1.XiButton6Click(Sender: TObject);
begin
 if (sg3.row<1) or (sg3.Cells[0,sg3.row]='') then exit;
  if MessageDlg(Format('Poista pelaaja '+sg3.Cells[0,sg3.row]+'?', []), mtConfirmation, mbYesNoCancel, 0) <> idYes then exit;
 deleterow(sg3, sg3.row);
 sg3.Invalidate;
 pelaajalista_tallennettu:=false;
end;

procedure TForm1.XiButton4Click(Sender: TObject);
begin
 if (sg1.row<1) or (sg1.Cells[0, sg1.Row]='') then exit;
 lisaapelaaja(sg3, sg1.Cells[0, sg1.Row], sg1.Cells[1, sg1.Row], sg1.Cells[2, sg1.Row]);
 deleterow(sg1, sg1.row);
 sortgrid(form1.sg3);
 sg1.Invalidate;
 pelaajalista_tallennettu:=false;
end;

procedure TForm1.XiButton5Click(Sender: TObject);
begin
 if (sg3.row<1) or (sg3.Cells[0, sg3.Row]='') then exit;
 lisaapelaaja(sg1, sg3.Cells[0, sg3.Row], sg3.Cells[1, sg3.Row], sg3.Cells[2, sg3.Row]);
 deleterow(sg3, sg3.row);
 sortgrid(form1.sg1);
 sg3.Invalidate;
 pelaajalista_tallennettu:=false;
end;

procedure TForm1.taysikierroksiaChange(Sender: TObject);
begin
 tarkista;
end;

procedure TForm1.sg2Exit(Sender: TObject);
begin
 sg2.col:=empty;
end;

procedure TForm1.ppelotClick(Sender: TObject);
var i, j: integer;
begin
 if tarkistapaivays=false then begin form1.paivaysexit(self); exit; end;
 if MessageDlg(Format('Pivitetn pelot ja tallennetaan?', []), mtConfirmation, mbYesNoCancel, 0)<>idYes then exit;
 for i:=1 to sg2.RowCount-1 do
  for j:=1 to sg1.RowCount-1 do
   if sg1.Cells[0,j]=sg2.cells[nimi,i] then sg1.Cells[2,j]:=sg2.cells[uusipelo,i];
 lataahistoria;
 tallenna_pelaajalista;
end;

procedure TForm1.XiButton8Click(Sender: TObject);
var f: textfile;
    tmpstr, tmpstr2, tmpstr3: string;
    i, j: integer;
begin
 if tarkistapaivays=false then begin form1.paivaysexit(self); exit; end;
 savedialog1.InitialDir:=stringreplace(ExtractFilePath(ParamStr(0)), '/', '\', [rfreplaceall]);
 savedialog1.filename:=stringreplace(otsikko.Text+paivays.text, '.', '_',[rfreplaceall]);
 if savedialog1.execute then
 begin
  if combobox2.itemindex=0 then
  begin
   tmpstr3:='<!--TAYSIK--><!--KIERROKSIA'+taysikierroksia.Text+'-->';
  end
  else begin tmpstr3:='<!--VAJAAK--><!--KIERROKSIA'+vajaakierroksia.Text+'-->'; end;
  AssignFile(F, savedialog1.filename);
  Rewrite(F);
  tmpstr:='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">'+#13#10+'<HTML>'+#13#10+'<HEAD>'+#13#10;
  tmpstr:=tmpstr+'<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=windows-1252">'+#13#10+'<TITLE></TITLE>'+#13#10;
  tmpstr:=tmpstr+'</HEAD>'+#13#10+'<BODY>'+tmpstr3+#13#10+'<P><U><FONT SIZE=4><B><!--Title-->'+otsikko.text+' <!--Date-->'+paivays.text+'</B></U></FONT></P>'+#13#10+'<TABLE BORDER=1 CELLPADDING=2 CELLSPACING=3>';
  writeln(F, tmpstr);
  for j:=0 to sg2.rowcount-1 do
  begin
   tmpstr:='<TR>';
   writeln(F, tmpstr);
   for i:=0 to sg2.colcount-2 do
    begin
    tmpstr2:=sg2.cells[i,j];
    if (tmpstr2='') or (tmpstr2=' ') then tmpstr2:='<BR>';
    if (i=0) and (j>0) then tmpstr:='<TD><P ALIGN=LEFT>'+inttostr(j)+'.</P></TD>' else tmpstr:='<TD><P ALIGN=LEFT>'+tmpstr2+'</P></TD>';
    if sg2.ColWidths[i]>0 then writeln(F, tmpstr);
    end;
   tmpstr:='</TR>';
   writeln(F, tmpstr);
  end;
  tmpstr:='</TABLE></BODY></HTML>';
  writeln(F, tmpstr);
  closefile(f);
  taulukko_tallennettu:=true;
 end;
end;

procedure TForm1.lopeta1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Yleisetasetukset1Click(Sender: TObject);
begin
 asetukset.top:=(Xipanel2.Height div 2)-asetukset.Height div 2;
 asetukset.left:=(Xipanel2.Width div 2)-asetukset.Width div 2;
 asetukset.Visible:=true;
end;

procedure TForm1.XiButton9Click(Sender: TObject);
begin
 opendialog1.DefaultExt:='*.html';
 opendialog1.filter:='htm taulukko|*.html';
 if opendialog1.Execute then
  if fileexists(opendialog1.filename) then avaahtm(opendialog1.filename);
 opendialog1.DefaultExt:='*.dat';
 opendialog1.filter:='Pelaajat lista|*.dat';
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
 if combobox2.itemindex=0 then begin taysikierroksia.Visible:=true; vajaakierroksia.Visible:=false; end;
 if combobox2.itemindex=1 then begin taysikierroksia.Visible:=false; vajaakierroksia.Visible:=true; end;
 tarkista;
end;

procedure TForm1.paivaysExit(Sender: TObject);
begin
 if tarkistapaivays=false then showmessage('Aseta pivmr oikein (piv.kuukausi.vuosi)');
end;

procedure TForm1.Poista1Click(Sender: TObject);
var j: integer;
begin
 if sg2.row<1 then exit;
 if sg2.rowcount=2 then
 begin
  for j:=0 to form1.sg2.colcount-1 do
   sg2.cells[j,sg2.row]:='';
  exit;
 end;
 deleterow(sg2, sg2.row);
 sg2.Invalidate;
end;

procedure TForm1.sg2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 if key=VK_delete then Poista1Click(self);
end;

procedure TForm1.Versio1Click(Sender: TObject);
begin
 MessageDlg('Pelonlaskenta'+#13#10#13#10+'Versio 1.00'+#13#10#13#10+'Email: info@pilvet.fi',mtCustom, [mbOk], 0);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 pl:=form1.sg1.ColWidths[1];
 pcl:=form1.pagecontrol1.width;
 form1.pagecontrol1.width:=form1.pagecontrol1.width-pl;
 form1.sg1.ColWidths[1]:=zero_width;
 form1.sg3.ColWidths[1]:=zero_width;
 up:=form1.sg2.ColWidths[form1.uusipelo];
 se:=form1.sg2.ColWidths[form1.seura];
 vp:=form1.sg2.ColWidths[form1.vanhapelo];
 mu:=form1.sg2.ColWidths[form1.muutos];
 ve:=form1.sg2.ColWidths[form1.vertailu];
 ry:=form1.sg2.ColWidths[form1.ryhma];
 si:=form1.sg2.ColWidths[form1.sija];
 cbuusipeloclick(self);
 sg1.SetFocus;
end;

procedure TForm1.gridKeyPress(Sender: TObject; var Key: Char);
var i: integer;
begin
 if key=#13 then
 begin
  if (sender as TStringGrid)=sg1 then sg1DblClick(self);
  if (sender as TStringGrid)=sg3 then XiButton5Click(self);
  taydennysTimer(self);
  exit;
 end;
 taydennys.enabled:=false; //reset timer!
 taydennys.enabled:=true;
 autocomplete:=autocomplete+key;
 for i:=1 to (sender as TStringGrid).RowCount-1 do
 begin
  if ansilowercase(copy((sender as TStringGrid).Cells[0,i], 1, length(autocomplete)))=ansilowercase(autocomplete) then
  begin
   (sender as TStrinGgrid).Row:=i;
   exit;
  end;
 end;
end;

procedure TForm1.taydennysTimer(Sender: TObject);
begin
 autocomplete:='';
 taydennys.enabled:=false;
end;

procedure TForm1.XiButton10Click(Sender: TObject);
begin
 uusipelaaja.Visible:=false;
end;

procedure TForm1.LuouusipelaajaClick(Sender: TObject);
var i, p: integer;
begin
 uudenpelaajannimi.text:=stringreplace(uudenpelaajannimi.text, ',', '.', [rfreplaceall]);
 uudenpelaajanseura.text:=stringreplace(uudenpelaajanseura.text, ',', '.', [rfreplaceall]);
 if length(uudenpelaajannimi.text)<5 then
 begin
  showmessage('Virheellinen pelaajan nimi!');
  exit;
 end;
 p:=kokonaisluvuksi(uudenpelaajanpelo.text);
 if (p<1000) or (p>3500) then
 begin
  showmessage('Virheellinen peloluku!');
  exit;
 end;
 if uudenpelaajantapa=1 then
 begin
  for i:=0 to form1.sg1.RowCount-1 do
   if ansilowercase(form1.sg1.Cells[0,i])=ansilowercase(uudenpelaajannimi.text) then
   begin
    showmessage('Pelaaja on jo aktiivisten listassa!');
    exit;
   end;
  for i:=0 to form1.sg3.RowCount-1 do
   if ansilowercase(form1.sg3.Cells[0,i])=ansilowercase(uudenpelaajannimi.text) then
   begin
    showmessage('Pelaaja on jo passiivisten listassa!');
    exit;
   end;
  lisaapelaaja(form1.sg1, uudenpelaajannimi.text, uudenpelaajanseura.text, uudenpelaajanpelo.text);
 end;
 if uudenpelaajantapa=2 then
 begin
  form1.sg1.cells[0,form1.sg1.row]:=uudenpelaajannimi.text;
  form1.sg1.cells[1,form1.sg1.row]:=uudenpelaajanseura.text;
  form1.sg1.cells[2,form1.sg1.row]:=uudenpelaajanpelo.text;
 end;
 form1.sortgrid(form1.sg1);
 uusipelaaja.Visible:=false;
 pelaajalista_tallennettu:=false;
end;

procedure TForm1.XiButton11Click(Sender: TObject);
begin
 cbuusipeloclick(self);
 asetukset.Visible:=false;
end;

procedure TForm1.cbuusipeloClick(Sender: TObject);
begin
 if cbuusipelo.checked=true then
  form1.sg2.ColWidths[form1.uusipelo]:=up
 else
  form1.sg2.ColWidths[form1.uusipelo]:=zero_width;
 if cbseura.checked=true then
  form1.sg2.ColWidths[form1.seura]:=se
 else
  form1.sg2.ColWidths[form1.seura]:=zero_width;
 if cbvanhapelo.checked=true then
  form1.sg2.ColWidths[form1.vanhapelo]:=vp
 else
  form1.sg2.ColWidths[form1.vanhapelo]:=zero_width;
 if cbvertailu.checked=true then
  form1.sg2.ColWidths[form1.vertailu]:=ve
 else
  form1.sg2.ColWidths[form1.vertailu]:=zero_width;
 if cbmuutos.checked=true then
  form1.sg2.ColWidths[form1.muutos]:=mu
 else
  form1.sg2.ColWidths[form1.muutos]:=zero_width;
 if cbryhma.checked=true then
  form1.sg2.ColWidths[form1.ryhma]:=ry
 else
  form1.sg2.ColWidths[form1.ryhma]:=zero_width;
 if cbsija.checked=true then
  form1.sg2.ColWidths[form1.sija]:=si
 else
  form1.sg2.ColWidths[form1.sija]:=zero_width;
end;

procedure TForm1.cbnaytaseuraClick(Sender: TObject);
begin
 if cbnaytaseura.checked=true then
 begin
  form1.PageControl1.Width:=pcl;
  form1.sg1.ColWidths[1]:=pl;
  form1.sg3.ColWidths[1]:=pl;
 end else
 begin
  form1.pagecontrol1.width:=form1.pagecontrol1.width-pl;
  form1.sg1.ColWidths[1]:=zero_width;
  form1.sg3.ColWidths[1]:=zero_width;
 end;
end;

procedure TForm1.PelityyppiChange(Sender: TObject);
var r: integer;
begin
 if (pelaajalista_tallennettu=false) then
 begin
  r:=MessageDlg(vakio_tallentamatta, mtConfirmation, mbYesNoCancel, 0);
  if r=idyes then tallenna_pelaajalista;
 end;
 if (taulukko_tallennettu=false) then
 begin
  r:=MessageDlg(vakio_tallentamatta2, mtConfirmation, mbYesNoCancel, 0);
  if r=idyes then XiButton8Click(self);
 end;
 if pelityyppi.itemindex=0 then
 begin
  if (ansilowercase(otsikko.text)='ketjukilpailu') or (ansilowercase(otsikko.text)='muu') then otsikko.text:='Pikapeli';
  taysikierroksia.Visible:=true;
  combobox2.enabled:=false;
  vajaakierroksia.Visible:=false;
  combobox2.ItemIndex:=0;
  cbryhma.Checked:=true;
  cbvanhapelo.Checked:=true;
  cbmuutos.Checked:=true;
  cbsija.Checked:=true;
  cbseura.Checked:=false;
  cbuusipelo.Checked:=true;
  cbvertailu.Checked:=false;
  cbnaytaseura.Checked:=false;
  pelopolku.text:='../pelot/pelo.php?nimi=';
  laske.Visible:=true;
  ppelot.visible:=true;
  pelaajalistan_nimi:=stringreplace(ExtractFilePath(ParamStr(0)), '/', '\', [rfreplaceall])+'pikapeli.dat';
 end;
 if pelityyppi.itemindex=1 then
 begin
  if (ansilowercase(otsikko.text)='pikapeli') or (ansilowercase(otsikko.text)='muu') then otsikko.text:='Ketjukilpailu';
  taysikierroksia.Visible:=false;
  combobox2.enabled:=false;
  vajaakierroksia.Visible:=true;
  vajaakierroksia.itemindex:=0;
  combobox2.ItemIndex:=1;
  cbryhma.Checked:=false;
  cbvanhapelo.Checked:=false;
  cbmuutos.Checked:=false;
  cbsija.Checked:=false;
  cbseura.Checked:=true;
  cbuusipelo.Checked:=false;
  cbvertailu.Checked:=true;
  cbnaytaseura.Checked:=true;
  pelopolku.text:='';
  laske.Visible:=false;
  ppelot.visible:=false;
  pelaajalistan_nimi:=stringreplace(ExtractFilePath(ParamStr(0)), '/', '\', [rfreplaceall])+'muukilpailu.dat';
 end;
 if pelityyppi.itemindex=2 then
 begin
  if (ansilowercase(otsikko.text)='pikapeli') or (ansilowercase(otsikko.text)='ketjukilpailu') then otsikko.text:='Muu';
  combobox2.enabled:=true;
  cbryhma.Checked:=false;
  cbvanhapelo.Checked:=false;
  cbmuutos.Checked:=false;
  cbsija.Checked:=true;
  cbseura.Checked:=true;
  cbuusipelo.Checked:=false;
  cbvertailu.Checked:=true;
  cbnaytaseura.Checked:=true;
  pelopolku.text:='';
  laske.Visible:=false;
  ppelot.visible:=false;
  pelaajalistan_nimi:=stringreplace(ExtractFilePath(ParamStr(0)), '/', '\', [rfreplaceall])+'muukilpailu.dat';
 end;
 lataa_pelaajalista(pelaajalistan_nimi);
 tarkista;
 pagecontrol1.activepageindex:=0;
 sg1.SetFocus;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var r: integer;
begin
 if (pelaajalista_tallennettu=false) then
 begin
  r:=MessageDlg(vakio_tallentamatta, mtConfirmation, mbYesNoCancel, 0);
  if r=idyes then tallenna_pelaajalista;
  if r=idcancel then begin canclose:=false; exit; end;
 end;
 if (taulukko_tallennettu=false) then
 begin
  r:=MessageDlg(vakio_tallentamatta2, mtConfirmation, mbYesNoCancel, 0);
  if r=idyes then XiButton8Click(self);
  if r=idcancel then begin canclose:=false; exit; end;
 end;
end;

Initialization
 MsgOptions.UseBorder:=True;
 MsgOptions.UseGradient:=True;
 MsgOptions.UseShapedForm:=True;
 MsgOptions.UseCustomFont:=True;
 MsgOptions.FormRoundSize:=40;
 MsgOptions.StartGradientColor:=clNavy;
 MsgOptions.EndGradientColor:=clBlack;
 MsgOptions.Font.Name:='Tahoma';
 MsgOptions.Font.Style:=[fsBold];
 MsgOptions.UseCustomButtons:=True;
 MsgOptions.UseCustomButtons:=True;
 MsgOptions.DefLang:=ltFinnish;
 MsgOptions.UseCustomPanel:=True;
end.
