unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MessDlgs, Grids, ExtCtrls, XiPanel, XiButton, StdCtrls, ShellApi;

type
  TForm5 = class(TForm)
    XiPanel1: TXiPanel;
    XiPanel2: TXiPanel;
    sg5: TStringGrid;
    SaveDialog1: TSaveDialog;
    otsikko: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    OpenDialog1: TOpenDialog;
    ComboBox1: TComboBox;
    footer: TMemo;
    XiButton1: TXiButton;
    XiButton2: TXiButton;
    XiButton4: TXiButton;
    XiButton3: TXiButton;
    XiButton5: TXiButton;
    XiButton6: TXiButton;
    Edit1: TEdit;
    Edit2: TEdit;
    XiButton7: TXiButton;
    luouusi: TXiPanel;
    liiga: TMemo;
    ketju: TMemo;
    procedure sg5DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure XiButton1Click(Sender: TObject);
    procedure sg5MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure otsikot;
    procedure XiButton3Click(Sender: TObject);
    procedure XiButton2Click(Sender: TObject);
    procedure XiButton4Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure sg5SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure XiButton5Click(Sender: TObject);
    procedure XiButton6Click(Sender: TObject);
    procedure XiButton7Click(Sender: TObject);
  private
    { Private declarations }
  public
      nimi, seura, ryhma, vanhapelo, pisteet, vertailu, uusipelo, muutos, parasta, sija, empty, undefined1, undefined2, undefined3, undefined4, undefined5, undefined6, undefined7, undefined8: integer;
      kilpailuja, lasketaan: integer;
      osakilpailut: array of string;
      tiedostonnimi: string;
    { Public declarations }
  end;

var
  Form5: TForm5;

implementation

uses Unit1;

{$R *.dfm}

procedure tee;
var i, j: integer;
begin
 for i:=1 to form5.sg5.rowcount-1 do
  for j:=0 to form5.sg5.colcount-1 do
   form5.sg5.cells[j,i]:='';
 form5.kilpailuja:=strtoint(form5.edit1.text);
 form5.lasketaan:=strtoint(form5.edit2.Text);
 form5.otsikot;
end;

procedure SortGrid3(Grid: TStringGrid; Col: integer);
var i, j, prev2: integer;
    a, b, prev: string;
    m: char;
    taulu: array of string;
    taulu2: array of integer;
    taulu3: array of array of string;
begin
 m:=decimalseparator;
 decimalseparator:='.';
 setlength(taulu, grid.rowCount);
 setlength(taulu2, grid.rowCount);
 setlength(taulu3, grid.colCount, grid.rowCount);
 for j:=1 to Grid.RowCount-1 do
 begin
  taulu[j]:=(Grid.Cells[Col, j]);
  taulu2[j]:=j;
 end;
 //vaihda:=false;
 for j:=0 to Grid.RowCount-1 do
  for i:=2 to Grid.RowCount-1 do
   begin
    a:=taulu[i];
    b:=taulu[i-1];
   {if vaihda=true then
    begin
     tmp:=a;
     a:=b;
     b:=tmp;
    end; }
    if (a<>'') and (b<>'') then
    begin
     if strtofloat(a)>strtofloat(b) then
     begin
      prev:=taulu[i-1];
      taulu[i-1]:=taulu[i];
      taulu[i]:=prev;
      prev2:=taulu2[i-1];
      taulu2[i-1]:=taulu2[i];
      taulu2[i]:=prev2;
      end;
    end;
 end;
 for i:=0 to grid.colcount-1 do
  for j:=1 to Grid.RowCount-1 do
   taulu3[i,j]:=Grid.cells[i,j];
 for i:=0 to grid.colcount-1 do
  for j:=1 to Grid.RowCount-1 do
   Grid.cells[i,j]:=taulu3[i, taulu2[j]];
 for j:=1 to Grid.RowCount-1 do
  Grid.cells[0, j]:='';
 decimalseparator:=m;
end;

function lasketotal(j, x, y: integer): string;
var a: array of extended;
    res, tmp: extended;
    b: array of integer;
    s: string;
    i, c, k, tmp2: integer;
    m: char;
begin
 setlength(a, x);
 setlength(b, x);
 m:=decimalseparator;
 decimalseparator:='.';
 res:=0;
 for i:=1 to x do
 begin
  s:=form5.sg5.cells[8+i, j];
  if (s=' ') or (s='') then s:='0';
  s:=stringreplace(s, ',','.',[]);
  s:=stringreplace(s,'*', '', [rfreplaceall]);
  a[i-1]:=strtofloat(s);
  b[i-1]:=8+i;
 end;
 for c:=0 to x do
  for k:=0 to x-2 do
   if a[k]<a[k+1] then begin tmp:=a[k]; a[k]:=a[k+1]; a[k+1]:=tmp; tmp2:=b[k]; b[k]:=b[k+1]; b[k+1]:=tmp2; end;
 for c:=0 to y-1 do
  res:=res+a[c];
 result:=floattostr(res);
 decimalseparator:=m;
 for c:=x-1 downto y do
  if (form5.sg5.cells[b[c], j]<>'') and (form5.sg5.cells[b[c], j]<>' ') then form5.sg5.cells[b[c], j]:='*'+stringreplace(form5.sg5.cells[b[c], j],'*', '', [rfreplaceall])
  else if ansipos('*', form5.sg5.cells[b[c], j])>0 then form5.sg5.cells[b[c], j]:=stringreplace(form5.sg5.cells[b[c], j], '*', '', [rfreplaceall]);
end;

procedure avaaosakilpailu(path: string; q: integer);
var f: textfile;
    TmpStr: string;
    x, lasku, i, j, t, r, k, l, rivi, sarake: integer;
    grid: TStringGrid;
    r1: extended;
    lasku2, onko, onko2: boolean;
    pistemaara, vanhapelo, uusipelo, pelaaja, seura: array of string;
    m: char;
begin
 form5.combobox1change(nil);
 m:=decimalseparator;
 decimalseparator:='.';
 grid:=TStringGrid.Create(nil);
 grid.rowcount:=2;
 grid.ColCount:=2;
 AssignFile(F, path);
 Reset(F);
 rivi:=0;
 sarake:=0;
 setlength(form5.osakilpailut, q+1);
 form5.osakilpailut[q]:='';
 while not eof(F) do
 begin
  readln(F, TmpStr);
  form5.osakilpailut[q]:=form5.osakilpailut[q]+tmpstr+#13#10;
  if ansipos('<!--vajaak-->', ansilowercase(tmpstr))>0 then begin form5.combobox1.itemindex:=1; form5.combobox1change(nil); end;
  if ansipos('<!--taysik-->', ansilowercase(tmpstr))>0 then begin form5.combobox1.itemindex:=0; form5.combobox1change(nil); end;
  x:=ansipos('<P ALIGN=LEFT>', ansiuppercase(tmpstr));
  if x>0 then
  begin
   tmpstr:=copy(tmpstr, x+14, length(tmpstr)-x-13);
   l:=ansipos('<a href', ansilowercase(tmpstr));
   if l>0 then
   begin
    tmpstr:=copy(tmpstr, ansipos('>', tmpstr)+1, length(tmpstr)-ansipos('>', tmpstr));
    tmpstr:=stringreplace(tmpstr, '</a>', '', [rfignorecase]);
   end;
   if sarake>=grid.colcount then grid.colcount:=sarake+1;
   if rivi>=grid.rowcount then grid.rowcount:=rivi+1;
   grid.Cells[sarake,rivi]:=stringreplace(copy(tmpstr, 1, ansipos('</P>', ansiuppercase(tmpstr))-1), '<BR>', '', [rfignorecase]);
   sarake:=sarake+1;
  end;
  if ansipos('</TR>', ansiuppercase(tmpstr))>0 then
  begin
   sarake:=0;
   rivi:=rivi+1;
  end;
 end;
 closefile(f);
 tmpstr:=copy(form5.osakilpailut[q], ansipos('<body>', ansilowercase(form5.osakilpailut[q])), length(form5.osakilpailut[q])-ansipos('<body>', ansilowercase(form5.osakilpailut[q])));
 tmpstr:=copy(tmpstr, 1, ansipos('</body>', ansilowercase(tmpstr))-1);
 tmpstr:=stringreplace(tmpstr, '<body>'+#13#10, '', [rfignorecase]);
 tmpstr:=stringreplace(tmpstr, '<body>', '', [rfignorecase]);
 form5.osakilpailut[q]:=tmpstr+#13#10;
 if form5.sg5.RowCount<grid.rowcount then form5.sg5.RowCount:=grid.rowcount;
 setlength(pistemaara,grid.rowcount);
 setlength(pelaaja,grid.rowcount);
 setlength(vanhapelo,grid.rowcount);
 setlength(uusipelo,grid.rowcount);
 setlength(seura,grid.rowcount);
 r:=12; // hmm
 for i:=0 to grid.ColCount-1 do
 begin
  if (ansilowercase(grid.Cells[i,0])='sija') and (form5.combobox1.itemindex=0) then
  begin
   for j:=1 to grid.rowCount-1 do
   begin
    lasku:=0;
    lasku2:=false;
    for t:=1 to grid.rowCount-1 do
     if t<>j then if grid.Cells[i,j]=grid.Cells[i,t] then begin lasku:=lasku+1; if t<j then lasku2:=true; end;
    if lasku2=false then
    begin
     r1:=0;
     for x:=r downto r-lasku do
      if x>0 then r1:=r1+x;
     r1:=r1/(lasku+1);
     pistemaara[j]:=floattostr(r1)
    end else pistemaara[j]:=pistemaara[j-1];
    r:=r-1;
    if r<0 then r:=0;
    lasku2:=false;
   end;
  end;
  if (ansilowercase(grid.Cells[i,0])='pisteet') and (form5.combobox1.itemindex=1) then
   for j:=1 to grid.rowcount-1 do
    pistemaara[j]:=grid.cells[i,j];
  if ansilowercase(grid.Cells[i,0])='pelaaja' then
   for j:=1 to grid.rowCount-1 do
    pelaaja[j]:=grid.cells[i,j];
  if ansilowercase(grid.Cells[i,0])='vanha pelo' then
   for j:=1 to grid.rowCount-1 do
    vanhapelo[j]:=grid.cells[i,j];
  if ansilowercase(grid.Cells[i,0])='uusi pelo' then
   for j:=1 to grid.rowCount-1 do
    uusipelo[j]:=grid.cells[i,j];
  if ansilowercase(grid.Cells[i,0])='seura' then
   for j:=1 to grid.rowCount-1 do
    seura[j]:=grid.cells[i,j];
 end;
 for j:=1 to grid.rowcount-1 do
 begin
  onko:=false;
  for i:=1 to form5.sg5.rowcount-1 do
   if pelaaja[j]=form5.sg5.cells[form5.nimi,i] then
   begin
    // Pelaaja on jo listassa
    form5.sg5.cells[q+8,i]:=pistemaara[j];
    if q=1 then form5.sg5.cells[form5.vanhapelo,i]:=vanhapelo[j];
    if q=form5.kilpailuja then form5.sg5.cells[form5.uusipelo,i]:=uusipelo[j];
    onko:=true;
    break;
   end;
  if onko=false then
  begin
   // Uusi pelaaja
   onko2:=false;
   for k:=1 to form5.sg5.rowcount-1 do
    if (form5.sg5.cells[form5.nimi,k]='') or (form5.sg5.cells[form5.nimi,k]=' ') then begin onko2:=true; break; end;
   if onko2=false then begin k:=form5.sg5.RowCount; form5.sg5.RowCount:=form5.sg5.RowCount+1; end;
   form5.sg5.cells[q+8,k]:=pistemaara[j];
   form5.sg5.cells[form5.nimi,k]:=pelaaja[j];
   form5.sg5.cells[form5.vanhapelo,k]:=vanhapelo[j];
   if q=form5.kilpailuja then form5.sg5.cells[form5.uusipelo,k]:=uusipelo[j];
   form5.sg5.cells[form5.seura,k]:=seura[j];
  end;
 end;
 for k:=1 to form5.sg5.rowcount-1 do
  form5.sg5.Cells[form5.parasta,k]:= lasketotal(k, form5.kilpailuja, form5.lasketaan);
 sortgrid3(form5.sg5, form5.parasta);
 form5.sg5.invalidate;
 grid.Free;
 decimalseparator:=m;
end;

procedure avaakokonaiskilpailu(path: string);
var f: textfile;
    temppi, TmpStr, paras, numero, kilpailu: string;
    laskija, kilpailujenmaara, x, i, j, k, l, rivi, sarake: integer;
    grid: TStringGrid;
    m: char;
begin
 kilpailujenmaara:=0;
 m:=decimalseparator;
 decimalseparator:='.';
 grid:=TStringgrid.Create(nil);
 grid.rowcount:=2;
 grid.ColCount:=2;
 AssignFile(F, path);
 Reset(F);
 rivi:=0;
 sarake:=0;
 while not eof(F) do
 begin
  readln(F, TmpStr);
  if ansipos('<!--title-->', ansilowercase(tmpstr))>0 then
     form5.otsikko.text:=copy(tmpstr, ansipos('<!--title-->', ansilowercase(tmpstr))+12, ansipos('<!--/title-->', ansilowercase(tmpstr)) - ansipos('<!--title-->', ansilowercase(tmpstr))-12);
  if ansipos('<!--osakilpailu', ansilowercase(tmpstr))>0 then break;
  x:=ansipos('<P ALIGN=LEFT>', ansiuppercase(tmpstr));
  if x>0 then
  begin
   tmpstr:=copy(tmpstr, x+14, length(tmpstr)-x-13);
   l:=ansipos('<a href', ansilowercase(tmpstr));
   if l>0 then
   begin
    tmpstr:=copy(tmpstr, ansipos('>', tmpstr)+1, length(tmpstr)-ansipos('>', tmpstr));
    tmpstr:=stringreplace(tmpstr, '</a>', '', [rfignorecase]);
   end;
   if sarake>=grid.colcount then grid.colcount:=sarake+1;
   if rivi>=grid.rowcount then grid.rowcount:=rivi+1;
   grid.Cells[sarake,rivi]:=stringreplace(copy(tmpstr, 1, ansipos('</P>', ansiuppercase(tmpstr))-1), '<BR>', '', [rfignorecase]);
   sarake:=sarake+1;
  end;
  if ansipos('<!--K-->', ansiuppercase(tmpstr))>0 then
   kilpailujenmaara:=kilpailujenmaara+1;
  if ansipos('<!--VAJAAKIERROS-->', ansiuppercase(tmpstr))>0 then
  begin
   form5.ComboBox1.ItemIndex:=1;
   form5.ComboBox1change(nil);
  end;
   if ansipos('<!--TAYSIKIERROS-->', ansiuppercase(tmpstr))>0 then
  begin
   form5.ComboBox1.ItemIndex:=0;
   form5.ComboBox1change(nil);
  end;
  if ansipos('</TR>', ansiuppercase(tmpstr))>0 then
  begin
   sarake:=0;
   rivi:=rivi+1;
  end;
  end;

  if ansipos('<!--osakilpailu', ansilowercase(tmpstr))>0 then
  begin
   setlength(form5.osakilpailut,100);
   numero:=copy(tmpstr,16,2);
   kilpailu:='';
   while not eof(F) do
   begin
   if ansipos('<!--footer', ansilowercase(tmpstr))>0 then break;
   readln(F, TmpStr);
   if ansipos('<!--osakilpailu', ansilowercase(tmpstr))>0 then
   begin
    numero:=copy(tmpstr,16,2);
    readln(F, TmpStr);
   end;
   if ansipos('<!--loppu-->', ansilowercase(tmpstr))>0 then
   begin
    form5.osakilpailut[strtoint(numero)]:=kilpailu;
    kilpailu:='';
   end else kilpailu:=kilpailu+tmpstr+#13#10;
   end;
  form5.footer.text:='';
  if ansipos('<!--footer-->', ansilowercase(tmpstr))>0 then
  begin
   while not eof(F) do
   begin
    readln(F, TmpStr);
    if ansipos('<!--loppu-->', ansilowercase(tmpstr))>0 then break;
    form5.footer.text:=form5.footer.text+tmpstr+#13#10;
   end;
  end;
  end;
  closefile(f);
  //if form5.combobox1.itemindex=0 then form5.sg5.ColWidths[form5.seura]:=-1 else form5.sg5.ColWidths[form5.seura]:=50;
  form5.combobox1change(nil);
  paras:='';
  for i:=0 to grid.ColCount-1 do
   if ansipos('<!--best-->', ansilowercase(grid.cells[i,0]))>0 then
   begin
    paras:=copy(grid.cells[i,0], ansipos('<!--best-->', grid.cells[i,0])+12, 2);
    paras:=stringreplace(paras, ' ', '', [rfreplaceall]);
   end;
  if paras='' then exit;
  form5.Edit1.Text:=inttostr(kilpailujenmaara);
  form5.Edit2.Text:=paras; //default arvoja
  form5.sg5.Cells[form5.parasta,0]:=paras+' Parasta';
  tee;
  laskija:=9;
  for i:=1 to form5.sg5.rowcount-1 do
   for j:=0 to form5.sg5.colcount-1 do
    form5.sg5.cells[j,i]:='';
  form5.sg5.RowCount:=grid.rowcount;
  for i:=0 to grid.ColCount-1 do
  begin
   for j:=0 to form5.sg5.colcount-1 do
   if grid.Cells[i,0]=form5.sg5.cells[j,0] then
   begin
    if j>0 then
    for k:=0 to grid.rowcount-1 do
     form5.sg5.cells[j,k]:=grid.Cells[i,k];
   end;
   if ansipos('<!--K-->', grid.Cells[i,0])>0 then
   begin
    temppi:=stringreplace(grid.Cells[i,0],'<!--K-->', '', []);
    form5.sg5.cells[laskija,0]:=temppi;
    for k:=1 to grid.rowcount-1 do
     form5.sg5.cells[laskija,k]:=grid.Cells[i,k];
    laskija:=laskija+1;
   end;
   if ansipos('<!--VP-->', grid.Cells[i,0])>0 then
   begin
    temppi:=stringreplace(grid.Cells[i,0],'<!--VP-->', '', []);
    form5.sg5.cells[form5.vanhapelo,0]:=temppi;
    for k:=1 to grid.rowcount-1 do
     form5.sg5.cells[form5.vanhapelo,k]:=grid.Cells[i,k];
   end;
   if ansipos('<!--UP-->', grid.Cells[i,0])>0 then
   begin
    temppi:=stringreplace(grid.Cells[i,0],'<!--UP-->', '', []);
    form5.sg5.cells[form5.uusipelo,0]:=temppi;
    for k:=1 to grid.rowcount-1 do
     form5.sg5.cells[form5.uusipelo,k]:=grid.Cells[i,k];
   end;
   if ansipos('<!--Best-->', grid.Cells[i,0])>0 then
   begin
    temppi:=stringreplace(grid.Cells[i,0],'<!--Best-->', '', []);
    form5.sg5.cells[form5.parasta,0]:=temppi;
    for k:=1 to grid.rowcount-1 do
     form5.sg5.cells[form5.parasta,k]:=grid.Cells[i,k];
   end;
  end;
 grid.Free;
 decimalseparator:=m;
end;

procedure TForm5.sg5DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
 if (aRow=0) then sg5.Canvas.Brush.Color:=tausta5
 else
  begin
   if aRow mod 2 = 0 then sg5.Canvas.Brush.Color:=tausta1 else sg5.Canvas.Brush.Color:=tausta2;
  end;
 if ansipos('*', sg5.Cells[acol, arow])>0 then
 begin
  sg5.Canvas.Brush.Color:=tausta4;
  sg5.Canvas.FillRect(Rect);
  sg5.Canvas.Textout(Rect.Left+2, Rect.Top+0, stringreplace(sg5.cells[acol, arow], '*', '', [rfreplaceall]));
  exit;
 end;
 sg5.Canvas.FillRect(Rect);
 if (acol=0) and (arow>0) then begin sg5.Canvas.Textout(Rect.Left + 2, Rect.Top + 0, inttostr(arow)+'.'); exit; end;
 sg5.Canvas.Textout(Rect.Left+2, Rect.Top+0, sg5.cells[acol, arow]);
end;

procedure TForm5.XiButton1Click(Sender: TObject);
begin
 luouusi.top:=(form5.Height div 2)-luouusi.Height div 2;
 luouusi.left:=(form5.Width div 2)-luouusi.Width div 2;
 luouusi.Visible:=true;
 if combobox1.itemindex=0 then footer.text:=liiga.text;
 if combobox1.itemindex=1 then footer.text:=ketju.text;
end;

procedure TForm5.sg5MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var c, r: longint;
    solu: string;
begin
 sg5.MouseToCell(X,Y,c,r);
 if r=0 then
 begin
  if (c>8) and (c<sg5.ColCount-10) then
  begin
   solu:=sg5.cells[c,0];
   solu:=InputBox('Osakilpailujen ajankohta', 'Anna osakilpailun '+inttostr(c-8)+'. ajankohta?', solu);
   sg5.cells[c,0]:=solu;
  end;
 end;
end;

procedure TForm5.otsikot;
var luku, i: integer;
begin
 luku:=kilpailuja;
 sg5.colcount:=19+luku;
 sg5.RowCount:=2;
 nimi:=1;
 seura:=2;
 ryhma:=3;
 vanhapelo:=4;
 undefined1:=5;
 undefined2:=6;
 undefined3:=7;
 undefined4:=8;
 parasta:=9+luku;
 uusipelo:=10+luku;
 muutos:=11+luku;
 vertailu:=12+luku;
 sija:=13+luku;
 undefined5:=14+luku;
 undefined6:=15+luku;
 undefined7:=16+luku;
 undefined8:=17+luku;
 empty:=18+luku;
 sg5.Cells[0,0]:='Nr';
 sg5.Cells[nimi,0]:='Pelaaja';
 sg5.Cells[seura,0]:='Seura';
 sg5.Cells[ryhma,0]:='Ryhm';
 sg5.Cells[vanhapelo,0]:='Vanha pelo';
 sg5.Cells[uusipelo,0]:='Uusi pelo';
 sg5.Cells[muutos,0]:='Muutos';
 sg5.Cells[parasta,0]:=inttostr(lasketaan)+' Parasta';
 sg5.Cells[vertailu,0]:='Vertailu';
 sg5.Cells[sija,0]:='Sija';
 sg5.ColWidths[0]:=20;
 sg5.ColWidths[nimi]:=110;
 form5.ComboBox1Change(self);
 sg5.ColWidths[parasta]:=60;
 sg5.ColWidths[sija]:=30;
 sg5.ColWidths[muutos]:=zero_width;
 sg5.ColWidths[vertailu]:=zero_width;
 sg5.ColWidths[empty]:=zero_width;
 sg5.ColWidths[undefined1]:=zero_width;
 sg5.ColWidths[undefined2]:=zero_width;
 sg5.ColWidths[undefined3]:=zero_width;
 sg5.ColWidths[undefined4]:=zero_width;
 sg5.ColWidths[undefined5]:=zero_width;
 sg5.ColWidths[undefined6]:=zero_width;
 sg5.ColWidths[undefined7]:=zero_width;
 sg5.ColWidths[undefined8]:=zero_width;
 for i:=9 to luku+8 do
  sg5.ColWidths[i]:=40;
 sg5.Col:=empty;
end;

function HTTPEncode(const AStr: string): string;
// The NoConversion set contains characters as specificed in RFC 1738 and
// should not be modified unless the standard changes.
const NoConversion = ['A'..'Z','a'..'z','*','@','.','_','-','0'..'9','$','!','''','(',')'];
var Sp, Rp: PChar;
begin
 SetLength(Result, Length(AStr)*3);
 Sp:=PChar(AStr);
 Rp:=PChar(Result);
 while Sp^<>#0 do
 begin
  if Sp^ in NoConversion then Rp^:=Sp^
  else if Sp^ = ' ' then Rp^:='+'
  else
  begin
   FormatBuf(Rp^, 3, '%%%.2x', 6, [Ord(Sp^)]);
   Inc(Rp,2);
  end;
  Inc(Rp);
  Inc(Sp);
 end;
 SetLength(Result, Rp-PChar(Result));
end;

procedure TForm5.XiButton3Click(Sender: TObject);
var f: textfile;
    tmpstr, tmpstr2, tmpstr3: string;
    i, j: integer;
begin
 savedialog1.InitialDir:=stringreplace(ExtractFilePath(ParamStr(0)), '/', '\', [rfreplaceall]);
 if savedialog1.execute then
 begin
  tiedostonnimi:=savedialog1.filename;
  AssignFile(F, savedialog1.filename);
  Rewrite(F);
  if combobox1.itemindex=0 then tmpstr3:='<!--TAYSIKIERROS-->' else tmpstr3:='<!--VAJAAKIERROS-->';
  tmpstr:='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">'+#13#10+'<HTML>'+#13#10+'<HEAD>'+#13#10;
  tmpstr:=tmpstr+'<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=windows-1252">'+#13#10+'<TITLE>'+otsikko.text+'</TITLE>'+#13#10;
  tmpstr:=tmpstr+'</HEAD>'+#13#10+'<BODY>'+tmpstr3+#13#10+'<P><U><FONT SIZE=5><B><!--title-->'+otsikko.text+'<!--/title--></B></U></FONT></P>'+#13#10+'<TABLE BORDER=1 CELLPADDING=2 CELLSPACING=3>';
  writeln(F, tmpstr);
  for j:=0 to sg5.rowcount-1 do
  begin
   tmpstr:='<TR>';
   writeln(F, tmpstr);
   for i:=0 to sg5.colcount-2 do
   begin
    tmpstr2:=sg5.cells[i,j];
    if (i=nimi) and (j>0) and (form1.pelopolku.text<>'') and (combobox1.itemindex=0) then tmpstr2:='<a href="'+form1.pelopolku.text+httpencode(tmpstr2)+'">'+tmpstr2+'</a>';
    if (tmpstr2='') or (tmpstr2=' ') then tmpstr2:='<BR>';
    if (j=0) and (i=parasta) then tmpstr2:='<!--Best-->'+tmpstr2;
    if (j=0) and (i=uusipelo) then tmpstr2:='<!--UP-->'+tmpstr2;
    if (j=0) and (i=vanhapelo) then tmpstr2:='<!--VP-->'+tmpstr2;
    if (j=0) and (i>8) and (i<=8+kilpailuja) then tmpstr2:='<!--K-->'+tmpstr2;
    if (j>0) and (i>8) and (i<=8+kilpailuja) and (ansipos('*', tmpstr2)>0) then tmpstr:='<TD BGCOLOR="#CCCCCC"><P ALIGN=LEFT>'+stringreplace(tmpstr2, '*', '', [rfreplaceall])+'</P></TD>'
    else if (i=0) and (j>0) then tmpstr:='<TD><P ALIGN=LEFT>'+inttostr(j)+'.</P></TD>' else tmpstr:='<TD><P ALIGN=LEFT>'+tmpstr2+'</P></TD>';
    if sg5.ColWidths[i]>0 then writeln(F, tmpstr);
   end;
   tmpstr:='</TR>';
   writeln(F, tmpstr);
  end;
  tmpstr:='</TABLE>';
  writeln(F, tmpstr);
  for i:=1 to length(osakilpailut)-1 do
   if osakilpailut[i]<>'' then
   begin
    tmpstr:='<!--Osakilpailu0'+inttostr(i)+'-->'+#13#10+osakilpailut[i]+'<!--Loppu-->';
    writeln(F, tmpstr);
   end;
  tmpstr:='<!--Footer-->'+#13#10+footer.text+'<!--Loppu-->';
  writeln(F, tmpstr);
  tmpstr:='</BODY></HTML>';
  writeln(F, tmpstr);
  closefile(f);
 end;
end;

procedure TForm5.XiButton2Click(Sender: TObject);
var k: integer;
begin
 opendialog1.DefaultExt:='*.html';
 opendialog1.filter:='htm taulukko|*.html;*.htm';
 if opendialog1.execute then
 begin
  tiedostonnimi:=opendialog1.filename;
  avaakokonaiskilpailu(opendialog1.filename);
  for k:=1 to form5.sg5.rowcount-1 do
   form5.sg5.Cells[form5.parasta,k]:=lasketotal(k, form5.kilpailuja, form5.lasketaan);
 sortgrid3(form5.sg5, form5.parasta);
 form5.sg5.invalidate;
 end;
end;

procedure TForm5.XiButton4Click(Sender: TObject);
var solu: string;
begin
 opendialog1.DefaultExt:='*.html';
 opendialog1.filter:='html osakilpailu|*.html;*.htm';
 solu:=InputBox('Lis osakilpailu', 'Anna osakilpailun numero 1-'+inttostr(kilpailuja)+'?', solu);
 if solu='' then exit;
 if (strtoint(solu)<=8) and (strtoint(solu)>kilpailuja) then begin showmessage('Avaa tai luo ensin kokonaiskilpailu!'); exit; end;
 if opendialog1.execute then avaaosakilpailu(opendialog1.filename, strtoint(solu));
end;

procedure TForm5.ComboBox1Change(Sender: TObject);
begin
 if combobox1.itemindex=0 then
 begin
  sg5.ColWidths[vanhapelo]:=60;
  sg5.ColWidths[uusipelo]:=60;
  sg5.ColWidths[seura]:=zero_width;
  sg5.ColWidths[ryhma]:=zero_width;
 end
 else
 begin
  sg5.ColWidths[seura]:=50;
  sg5.ColWidths[vanhapelo]:=zero_width;
  sg5.ColWidths[uusipelo]:=zero_width;
  sg5.ColWidths[ryhma]:=zero_width;
 end;
end;

procedure TForm5.sg5SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
 if (arow>0) and ((acol=sija) or (acol=ryhma) or (acol=uusipelo)) then sg5.options:=sg5.Options+[goediting] else sg5.options:=sg5.Options-[goediting];
end;

procedure avaalinkki(linkki: string);
var s: pansichar;
begin
 s:=pchar(linkki);
 ShellExecute(form5.Handle, 'open', s, nil, nil, SW_SHOWNORMAL);
end;

procedure TForm5.XiButton5Click(Sender: TObject);
begin
 if fileexists(tiedostonnimi) then avaalinkki(tiedostonnimi);
end;

procedure TForm5.XiButton6Click(Sender: TObject);
var p1, p2: integer;
begin
 p1:=form1.kokonaisluvuksi(edit1.text);
 if (p1<4) or (p1>20) then begin edit1.text:=''; exit; end;
 p2:=form1.kokonaisluvuksi(edit2.text);
 if (p2<3) or (p2>p1) then begin edit2.text:=''; exit; end;
 tee;
 luouusi.Visible:=false;
end;

procedure TForm5.XiButton7Click(Sender: TObject);
begin
 luouusi.Visible:=false;
end;

end.
